3 # A library of functions shared by the various scripts in this directory.
5 # This is the timestamp about when we merged changed to include licenses
6 # with Arvados packages. We use it as a heuristic to add revisions for
8 LICENSE_PACKAGE_TS=20151208015500
11 echo "$@" >"$STDOUT_IF_DEBUG"
15 for version_suffix in "$@"; do
16 if "easy_install$version_suffix" --version >/dev/null 2>&1; then
17 echo "easy_install$version_suffix"
24 Error: easy_install$1 (from Python setuptools module) not found
30 format_last_commit_here() {
31 local format="$1"; shift
32 TZ=UTC git log -n1 --first-parent "--format=format:$format" .
36 # Generates a version number from the git log for the current working
37 # directory, and writes it to stdout.
39 declare $(format_last_commit_here "git_ts=%ct git_hash=%h")
40 echo "0.1.$(date -ud "@$git_ts" +%Y%m%d%H%M%S).$git_hash"
43 nohash_version_from_git() {
44 version_from_git | cut -d. -f1-3
47 timestamp_from_git() {
48 format_last_commit_here "%ct"
51 handle_python_package () {
52 # This function assumes the current working directory is the python package directory
53 if [ -n "$(find dist -name "*-$(nohash_version_from_git).tar.gz" -print -quit)" ]; then
54 # This package doesn't need rebuilding.
57 # Make sure only to use sdist - that's the only format pip can deal with (sigh)
58 python setup.py $DASHQ_UNLESS_DEBUG sdist
62 local gem_name="$1"; shift
63 local gem_version="$(nohash_version_from_git)"
64 local gem_src_dir="$(pwd)"
66 if ! [[ -e "${gem_name}-${gem_version}.gem" ]]; then
67 find -maxdepth 1 -name "${gem_name}-*.gem" -delete
69 # -q appears to be broken in gem version 2.2.2
70 $GEM build "$gem_name.gemspec" $DASHQ_UNLESS_DEBUG >"$STDOUT_IF_DEBUG" 2>"$STDERR_IF_DEBUG"
74 # Usage: package_go_binary services/foo arvados-foo "Compute foo to arbitrary precision"
76 local src_path="$1"; shift
77 local prog="$1"; shift
78 local description="$1"; shift
79 local license_file="${1:-agpl-3.0.txt}"; shift
81 debug_echo "package_go_binary $src_path as $prog"
83 local basename="${src_path##*/}"
85 mkdir -p "$GOPATH/src/git.curoverse.com"
86 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git"
88 cd "$GOPATH/src/git.curoverse.com/arvados.git/$src_path"
89 local version="$(version_from_git)"
90 local timestamp="$(timestamp_from_git)"
92 # If the command imports anything from the Arvados SDK, bump the
93 # version number and build a new package whenever the SDK changes.
94 if grep -qr git.curoverse.com/arvados .; then
95 cd "$GOPATH/src/git.curoverse.com/arvados.git/sdk/go"
96 if [[ $(timestamp_from_git) -gt "$timestamp" ]]; then
97 version=$(version_from_git)
101 cd $WORKSPACE/packages/$TARGET
102 go get "git.curoverse.com/arvados.git/$src_path"
103 fpm_build "$GOPATH/bin/$basename=/usr/bin/$prog" "$prog" 'Curoverse, Inc.' dir "$version" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=$description" "$WORKSPACE/$license_file=/usr/share/doc/$prog/$license_file"
106 default_iteration() {
107 local package_name="$1"; shift
108 local package_version="$1"; shift
110 if [[ $package_version =~ ^0\.1\.([0-9]{14})(\.|$) ]] && \
111 [[ ${BASH_REMATCH[1]} -le $LICENSE_PACKAGE_TS ]]; then
117 _build_rails_package_scripts() {
118 local pkgname="$1"; shift
119 local destdir="$1"; shift
120 local srcdir="$RUN_BUILD_PACKAGES_PATH/rails-package-scripts"
121 for scriptname in postinst prerm postrm; do
122 cat "$srcdir/$pkgname.sh" "$srcdir/step2.sh" "$srcdir/$scriptname.sh" \
123 >"$destdir/$scriptname" || return $?
127 handle_rails_package() {
128 local pkgname="$1"; shift
129 local srcdir="$1"; shift
130 local license_path="$1"; shift
131 local scripts_dir="$(mktemp --tmpdir -d "$pkgname-XXXXXXXX.scripts")" && \
132 local version_file="$(mktemp --tmpdir "$pkgname-XXXXXXXX.version")" && (
134 _build_rails_package_scripts "$pkgname" "$scripts_dir"
137 version_from_git >"$version_file"
138 git rev-parse HEAD >git-commit.version
141 if [[ 0 != "$?" ]] || ! cd "$WORKSPACE/packages/$TARGET"; then
142 echo "ERROR: $pkgname package prep failed" >&2
143 rm -rf "$scripts_dir" "$version_file"
147 local railsdir="/var/www/${pkgname%-server}/current"
148 local -a pos_args=("$srcdir/=$railsdir" "$pkgname" "Curoverse, Inc." dir
149 "$(cat "$version_file")")
150 local license_arg="$license_path=$railsdir/$(basename "$license_path")"
151 # --iteration=3 accommodates the package scripts change from #8014.
152 local -a switches=(--iteration=3
153 --after-install "$scripts_dir/postinst"
154 --before-remove "$scripts_dir/prerm"
155 --after-remove "$scripts_dir/postrm")
156 # For some reason fpm excludes need to not start with /.
157 local exclude_root="${railsdir#/}"
158 # .git and packages are for the SSO server, which is built from its
160 for exclude in .git packages tmp log coverage \
161 Capfile\* config/deploy\* \
162 config/application.yml \
163 config/database.yml; do
164 switches+=(-x "$exclude_root/$exclude")
166 fpm_build "${pos_args[@]}" "${switches[@]}" \
167 -x "$exclude_root/vendor/bundle" "$@" "$license_arg"
168 rm -rf "$scripts_dir" "$version_file"
171 # Build packages for everything
173 # The package source. Depending on the source type, this can be a
174 # path, or the name of the package in an upstream repository (e.g.,
178 # The name of the package to build. Defaults to $PACKAGE.
179 PACKAGE_NAME=${1:-$PACKAGE}
181 # Optional: the vendor of the package. Should be "Curoverse, Inc." for
182 # packages of our own software. Passed to fpm --vendor.
185 # The type of source package. Passed to fpm -s. Default "python".
186 PACKAGE_TYPE=${1:-python}
188 # Optional: the package version number. Passed to fpm -v.
192 case "$PACKAGE_TYPE" in
194 # All Arvados Python2 packages depend on Python 2.7.
195 # Make sure we build with that for consistency.
196 set -- "$@" --python-bin python2.7 \
197 --python-easyinstall "$EASY_INSTALL2" \
198 --python-package-name-prefix "$PYTHON2_PKG_PREFIX" \
199 --depends "$PYTHON2_PACKAGE"
202 # fpm does not actually support a python3 package type. Instead
203 # we recognize it as a convenience shortcut to add several
204 # necessary arguments to fpm's command line later, after we're
205 # done handling positional arguments.
207 set -- "$@" --python-bin python3 \
208 --python-easyinstall "$EASY_INSTALL3" \
209 --python-package-name-prefix "$PYTHON3_PKG_PREFIX" \
210 --depends "$PYTHON3_PACKAGE"
214 declare -a COMMAND_ARR=("fpm" "--maintainer=Ward Vandewege <ward@curoverse.com>" "-s" "$PACKAGE_TYPE" "-t" "$FORMAT")
215 if [ python = "$PACKAGE_TYPE" ]; then
216 COMMAND_ARR+=(--exclude=\*/{dist,site}-packages/tests/\*)
219 if [[ "$PACKAGE_NAME" != "$PACKAGE" ]]; then
220 COMMAND_ARR+=('-n' "$PACKAGE_NAME")
223 if [[ "$VENDOR" != "" ]]; then
224 COMMAND_ARR+=('--vendor' "$VENDOR")
227 if [[ "$VERSION" != "" ]]; then
228 COMMAND_ARR+=('-v' "$VERSION")
230 # We can always add an --iteration here. If another one is specified in $@,
231 # that will take precedence, as desired.
232 COMMAND_ARR+=(--iteration "$(default_iteration "$PACKAGE" "$VERSION")")
234 # 'dir' type packages are provided in the form /path/to/source=/path/to/dest
235 # so strip off the 2nd part to check for fpm-info below.
236 PACKAGE_DIR=$(echo $PACKAGE | sed 's/\/=.*//')
238 # Append --depends X and other arguments specified by fpm-info.sh in
239 # the package source dir. These are added last so they can override
240 # the arguments added by this script.
241 declare -a fpm_args=()
242 declare -a fpm_depends=()
243 if [[ -d "$PACKAGE_DIR" ]]; then
244 FPM_INFO="$PACKAGE_DIR/fpm-info.sh"
246 FPM_INFO="${WORKSPACE}/backports/${PACKAGE_TYPE}-${PACKAGE}/fpm-info.sh"
248 if [[ -e "$FPM_INFO" ]]; then
249 debug_echo "Loading fpm overrides from $FPM_INFO"
252 for i in "${fpm_depends[@]}"; do
253 COMMAND_ARR+=('--depends' "$i")
256 # Append remaining function arguments directly to fpm's command line.
261 COMMAND_ARR+=("${fpm_args[@]}")
263 COMMAND_ARR+=("$PACKAGE")
265 debug_echo -e "\n${COMMAND_ARR[@]}\n"
267 FPM_RESULTS=$("${COMMAND_ARR[@]}")
270 fpm_verify $FPM_EXIT_CODE $FPM_RESULTS
273 # verify build results
280 if [[ $FPM_RESULTS =~ ([A-Za-z0-9_\.-]*\.)(deb|rpm) ]]; then
281 FPM_PACKAGE_NAME=${BASH_REMATCH[1]}${BASH_REMATCH[2]}
284 if [[ "$FPM_PACKAGE_NAME" == "" ]]; then
286 echo "Error: $PACKAGE: Unable to figure out package name from fpm results:"
290 elif [[ "$FPM_RESULTS" =~ "File already exists" ]]; then
291 echo "Package $FPM_PACKAGE_NAME exists, not rebuilding"
292 elif [[ 0 -ne "$FPM_EXIT_CODE" ]]; then
293 echo "Error building package for $1:\n $FPM_RESULTS"
299 if [[ "$FORMAT" == "deb" ]]; then
300 $SUDO apt-get install $PACKAGES --yes
301 elif [[ "$FORMAT" == "rpm" ]]; then
302 $SUDO yum -q -y install $PACKAGES